/*

USER LIMITATION LIBRARY
To use this library:
--------------
1) Double your .dme file in the File tree
2) Between "New source code should be placed in .dm files: choose File/New --> Code File." and "BEGIN_INTERNALS":
 -define your maximum user number by using SINGLE_USER, DUAL_USER, or USERMAX *.
 -define MAX_OUTPUT, which is what will be displayed, or define MAX_OUTPUT as null to display no message.

*/

var/pl_count = 0 as num
client/New()
	#ifdef USERMAX
	if(USERMAX <= 0)
		#undef USERMAX
	#endif
	#ifdef USERMAX
	if(pl_count == USERMAX)
		if(MAX_OUTPUT != null) src << MAX_OUTPUT
		del src
	else
		pl_count += 1
		goto END
	#endif
	#ifdef SINGLE_USER
	if(pl_count == 1)
		if(MAX_OUTPUT != null) src << MAX_OUTPUT
		del src
	else
		pl_count = 1
		goto END
	#endif
	#ifdef DUAL_USER
	if(pl_count == 2)
		if(MAX_OUTPUT != null) src << MAX_OUTPUT
		del src
	else
		pl_count += 1
	#endif
	goto END
	END
	..()
#ifndef MAX_OUTPUT
var/const/MAX_OUTPUT = "The maximum number of users for this world has been reached."
#endif